package org.kantega.jexmec;

/*
 * Copyright 2010 Kantega AS
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * Provides access to a service of type T by name. Used by {@link org.kantega.jexmec.simple.SimpleConstructorPluginLoader}
 * to give plugins access a named service of a type of which there are multiple implementations available.
 * @see org.kantega.jexmec.simple.SimpleConstructorPluginLoader
 */
public interface NamedService<T> {
    /**
     * Returns the service named <code>name</code>
     * @param name the name of the service to return
     * @return the service named <code>name</code>
     */
    public T get(String name);
}
